diff --git a/src/sshmasterconnection.cpp b/src/sshmasterconnection.cpp
index 8b59fe7..424cad2 100644
--- a/src/sshmasterconnection.cpp
+++ b/src/sshmasterconnection.cpp
@@ -588,129 +577,129 @@ void SshMasterConnection::run()
     {
         socket_t proxysocket = SSH_INVALID_SOCKET;
 
-        tcpNetworkProxy = new QNetworkProxy( QNetworkProxy::HttpProxy,
-                                             proxyserver, proxyport, proxylogin, proxypassword);
+        tcpNetworkProxy = new QNetworkProxy(QNetworkProxy::HttpProxy,
+                                            proxyserver, proxyport, proxylogin, proxypassword);
         tcpProxySocket = new QTcpSocket();
-        tcpProxySocket->setProxy( *tcpNetworkProxy );
+        tcpProxySocket->setProxy(*tcpNetworkProxy);
         tcpProxySocket->connectToHost(host, port);
         if (!tcpProxySocket->waitForConnected(30000))
         {
-            QString message=tr ( "Cannot connect to proxy server." );
-            x2goDebug<<message<<endl;
-            emit connectionError ( "Proxy", message );
-            ssh_free ( my_ssh_session );
+            QString message = tr("Cannot connect to proxy server.");
+            x2goDebug << message << endl;
+            emit connectionError("Proxy", message);
+            ssh_free(my_ssh_session);
             quit();
             return;
         }
         proxysocket = tcpProxySocket->socketDescriptor();
         x2goDebug << "Created HTTP proxy socket: " << proxysocket << endl;
-        ssh_options_set( my_ssh_session, SSH_OPTIONS_FD, &proxysocket);
-        ssh_set_fd_toread( my_ssh_session);
-        x2goDebug<<"Connected to HTTP proxy server: " << proxyserver << ":"
-                 << proxyport <<endl;
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_FD, &proxysocket);
+        ssh_set_fd_toread(my_ssh_session);
+        x2goDebug << "Connected to HTTP proxy server: " << proxyserver << ":"
+                  << proxyport << endl;
     }
 
-    if ( !sshConnect() )
+    if (!sshConnect())
     {
-        if(disconnectSessionFlag)
+        if (disconnectSessionFlag)
         {
-            x2goDebug<<"Session is already disconnected, exiting."<<endl;
+            x2goDebug << "Session is already disconnected, exiting." << endl;
             return;
         }
-        QString err=ssh_get_error ( my_ssh_session );
-        QString message=tr ( "Cannot connect to " ) +host+":"+QString::number ( port );
-        x2goDebug<<message<<" - "<<err;
-        emit connectionError ( message, err );
-        ssh_free ( my_ssh_session );
+        QString err = ssh_get_error(my_ssh_session);
+        QString message = tr("Cannot connect to ") + host + ":" + QString::number(port);
+        x2goDebug << message << " - " << err;
+        emit connectionError(message, err);
+        ssh_free(my_ssh_session);
         quit();
         return;
     }
-    if(disconnectSessionFlag)
+    if (disconnectSessionFlag)
     {
-        x2goDebug<<"Session is already disconnected, exiting."<<endl;
+        x2goDebug << "Session is already disconnected, exiting." << endl;
         return;
     }
     QString errMsg;
-    int state=serverAuth ( errMsg );
-    if ( state != SSH_SERVER_KNOWN_OK )
+    int state = serverAuth(errMsg);
+    if (state != SSH_SERVER_KNOWN_OK)
     {
-        if(disconnectSessionFlag)
+        if (disconnectSessionFlag)
         {
-            x2goDebug<<"Session is already disconnected, exiting."<<endl;
+            x2goDebug << "Session is already disconnected, exiting." << endl;
             return;
         }
-        writeHostKey=writeHostKeyReady=false;
-        emit serverAuthError ( state,errMsg, this );
-        for(;;)
+        writeHostKey = writeHostKeyReady = false;
+        emit serverAuthError(state, errMsg, this);
+        for (;;)
         {
             this->usleep(100);
             writeHostKeyMutex.lock();
-            if(writeHostKeyReady)
+            if (writeHostKeyReady)
             {
-                if(writeHostKey)
+                if (writeHostKey)
                     ssh_write_knownhost(my_ssh_session);
                 writeHostKeyMutex.unlock();
                 break;
             }
             writeHostKeyMutex.unlock();
         }
-        ssh_disconnect ( my_ssh_session );
-        ssh_free ( my_ssh_session );
+        ssh_disconnect(my_ssh_session);
+        ssh_free(my_ssh_session);
         return;
     }
 
-    if(disconnectSessionFlag)
+    if (disconnectSessionFlag)
     {
-        x2goDebug<<"Session is already disconnected, exiting."<<endl;
+        x2goDebug << "Session is already disconnected, exiting." << endl;
         return;
     }
 
-    QByteArray tmp_BA = user.toLocal8Bit ();
-    ssh_options_set ( my_ssh_session, SSH_OPTIONS_USER, tmp_BA.data () );
+    QByteArray tmp_BA = user.toLocal8Bit();
+    ssh_options_set(my_ssh_session, SSH_OPTIONS_USER, tmp_BA.data());
 
 #ifdef Q_OS_WIN
     {
-        QByteArray tmp_BA = (mainWnd->getHomeDirectory () + "/ssh").toLocal8Bit ();
+        QByteArray tmp_BA = (mainWnd->getHomeDirectory() + "/ssh").toLocal8Bit();
 
-        ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, tmp_BA.data () );
-        x2goDebug << "Setting SSH directory to " << tmp_BA.data ();
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_SSH_DIR, tmp_BA.data());
+        x2goDebug << "Setting SSH directory to " << tmp_BA.data();
     }
 #endif
 
-    if ( userAuth() )
+    if (userAuth())
     {
-        if(disconnectSessionFlag)
+        if (disconnectSessionFlag)
         {
-            x2goDebug<<"Session is already disconnected, exiting."<<endl;
+            x2goDebug << "Session is already disconnected, exiting." << endl;
             return;
         }
-        x2goDebug<<"User authentication OK.";
+        x2goDebug << "User authentication OK.";
         // checkLogin() is currently specific to libssh.
-        if(kerberos)
+        if (kerberos)
         {
             emit connectionOk(host);
         }
-        else if(this->loginCheck == false)
+        else if (this->loginCheck == false)
         {
-            x2goDebug<<"Skipping Login Check as requested by configuration";
+            x2goDebug << "Skipping Login Check as requested by configuration";
             emit connectionOk(host);
         }
         else
         {
-            if(checkLogin())
+            if (checkLogin())
             {
-                x2goDebug<<"Login Check - OK";
+                x2goDebug << "Login Check - OK";
                 emit connectionOk(host);
             }
             else
             {
-                x2goDebug<<"Login Check - Failed";
-//          if(!interactionInterrupt)
+                x2goDebug << "Login Check - Failed";
+                //          if(!interactionInterrupt)
                 {
-                  emit finishInteraction(this);
+                    emit finishInteraction(this);
                 }
-                ssh_disconnect ( my_ssh_session );
-                ssh_free ( my_ssh_session );
+                ssh_disconnect(my_ssh_session);
+                ssh_free(my_ssh_session);
                 quit();
                 return;
             }
@@ -718,105 +707,104 @@ void SshMasterConnection::run()
     }
     else
     {
-        if(disconnectSessionFlag)
+        if (disconnectSessionFlag)
         {
-            x2goDebug<<"Session is already disconnected, exiting."<<endl;
+            x2goDebug << "Session is already disconnected, exiting." << endl;
             return;
         }
         QString err;
         if (!kerberos)
         {
-            err=ssh_get_error ( my_ssh_session );
+            err = ssh_get_error(my_ssh_session);
         }
         else
         {
-            err=sshProcErrString;
+            err = sshProcErrString;
         }
-        QString message=tr ( "Authentication failed." );
-        x2goDebug<<message<<" - "<<err;
-        emit userAuthError ( authErrors.join ( "\n" ) );
-        ssh_disconnect ( my_ssh_session );
-        ssh_free ( my_ssh_session );
+        QString message = tr("Authentication failed.");
+        x2goDebug << message << " - " << err;
+        emit userAuthError(authErrors.join("\n"));
+        ssh_disconnect(my_ssh_session);
+        ssh_free(my_ssh_session);
         quit();
         return;
     }
 
-
 #ifndef Q_OS_WIN
-    const int y=1;
+    const int y = 1;
 #else
-    const char y=1;
+    const char y = 1;
 #endif
-    socket_t session_sock=ssh_get_fd(my_ssh_session);
-    setsockopt(session_sock, IPPROTO_TCP, TCP_NODELAY,&y, sizeof(int));
-
+    socket_t session_sock = ssh_get_fd(my_ssh_session);
+    setsockopt(session_sock, IPPROTO_TCP, TCP_NODELAY, &y, sizeof(int));
 
     channelLoop();
 }
 
-
 SshMasterConnection::~SshMasterConnection()
 {
 
     disconnectFlagMutex.lock();
-    disconnectSessionFlag=true;
+    disconnectSessionFlag = true;
     disconnectFlagMutex.unlock();
-    x2goDebug<<"SshMasterConnection, instance "<<this<<" waiting for thread to finish.";
+    x2goDebug << "SshMasterConnection, instance " << this << " waiting for thread to finish.";
     wait(15000);
-    x2goDebug<<"SshMasterConnection, instance "<<this<<" thread finished.";
-    for(int i=processes.count()-1; i>=0; --i)
+    x2goDebug << "SshMasterConnection, instance " << this << " thread finished.";
+    for (int i = processes.count() - 1; i >= 0; --i)
     {
         delete processes[i];
     }
-    x2goDebug<<"SshMasterConnection, instance "<<this<<" finished destructor.";
+    x2goDebug << "SshMasterConnection, instance " << this << " finished destructor.";
 }
 
-
 bool SshMasterConnection::sshConnect()
 {
     int rc;
     QByteArray tmpBA = host.toLocal8Bit();
-    if(useproxy && proxytype==PROXYSSH)
+    if (useproxy && proxytype == PROXYSSH)
     {
-        ssh_options_set ( my_ssh_session, SSH_OPTIONS_HOST, "127.0.0.1" );
-        if (localProxyPort) {
-            ssh_options_set ( my_ssh_session, SSH_OPTIONS_PORT, &localProxyPort );
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_HOST, "127.0.0.1");
+        if (localProxyPort)
+        {
+            ssh_options_set(my_ssh_session, SSH_OPTIONS_PORT, &localProxyPort);
         }
     }
     else
     {
-        ssh_options_set ( my_ssh_session, SSH_OPTIONS_HOST, tmpBA.data() );
-        if (port) {
-            ssh_options_set ( my_ssh_session, SSH_OPTIONS_PORT, &port );
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_HOST, tmpBA.data());
+        if (port)
+        {
+            ssh_options_set(my_ssh_session, SSH_OPTIONS_PORT, &port);
         }
     }
 
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
     unsigned int cur_port = 0;
-    ssh_options_get_port (my_ssh_session, &cur_port);
+    ssh_options_get_port(my_ssh_session, &cur_port);
     x2goDebug << "Session port before config file parse: " << cur_port;
 #endif
 
     /* Parse ~/.ssh/config. */
-    if (ssh_options_parse_config (my_ssh_session, NULL) < 0) {
+    if (ssh_options_parse_config(my_ssh_session, NULL) < 0)
+    {
         x2goDebug << "Warning: unable to parse the SSH config file.";
     }
 
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-    ssh_options_get_port (my_ssh_session, &cur_port);
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+    ssh_options_get_port(my_ssh_session, &cur_port);
     x2goDebug << "Session port after config file parse: " << cur_port;
 #endif
 
-    rc = ssh_connect ( my_ssh_session );
-    if ( rc != SSH_OK )
+    rc = ssh_connect(my_ssh_session);
+    if (rc != SSH_OK)
     {
         return false;
     }
-//set values for remote host for proper server authentication
-    if(useproxy && proxytype==PROXYSSH)
+    //set values for remote host for proper server authentication
+    if (useproxy && proxytype == PROXYSSH)
     {
         x2goDebug << "Connected via proxy, resetting connection values on session to " << tmpBA.data() << ":" << port;
-        ssh_options_set ( my_ssh_session, SSH_OPTIONS_HOST, tmpBA.data() );
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_HOST, tmpBA.data());
 
         /*
          * The SSH port might be 0, which indicates to use the default port
@@ -834,205 +822,207 @@ bool SshMasterConnection::sshConnect()
         int work_port = port;
 
         /* Oh, yeah, and we don't really support port values of 0 for pre-0.6.0 libssh. Sorry. */
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-        if (!work_port) {
-            ssh_session tmp_session = ssh_new ();
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+        if (!work_port)
+        {
+            ssh_session tmp_session = ssh_new();
 
-            if (!tmp_session) {
-                QString error_msg = tr ("Cannot create SSH session.");
+            if (!tmp_session)
+            {
+                QString error_msg = tr("Cannot create SSH session.");
                 x2goDebug << error_msg;
                 return (false);
             }
-            else {
-                ssh_options_set (tmp_session, SSH_OPTIONS_HOST, tmpBA.data ());
+            else
+            {
+                ssh_options_set(tmp_session, SSH_OPTIONS_HOST, tmpBA.data());
 
                 /* Parse ~/.ssh/config. */
-                if (ssh_options_parse_config (tmp_session, NULL) < 0) {
+                if (ssh_options_parse_config(tmp_session, NULL) < 0)
+                {
                     x2goDebug << "Warning: unable to parse the SSH config file.";
                 }
 
                 unsigned int inferred_port = 0;
-                ssh_options_get_port (tmp_session, &inferred_port);
+                ssh_options_get_port(tmp_session, &inferred_port);
                 x2goDebug << "Fetched inferred session port: " << inferred_port;
 
                 work_port = inferred_port & 0xFFFF;
 
-                ssh_free (tmp_session);
+                ssh_free(tmp_session);
             }
         }
 #endif
 
-        ssh_options_set ( my_ssh_session, SSH_OPTIONS_PORT, &work_port );
+        ssh_options_set(my_ssh_session, SSH_OPTIONS_PORT, &work_port);
     }
 
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-    ssh_options_get_port (my_ssh_session, &cur_port);
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+    ssh_options_get_port(my_ssh_session, &cur_port);
     x2goDebug << "Session port before config file parse (part 2): " << cur_port;
 #endif
 
     /* Parse ~/.ssh/config. */
-    if (ssh_options_parse_config (my_ssh_session, NULL) < 0) {
+    if (ssh_options_parse_config(my_ssh_session, NULL) < 0)
+    {
         x2goDebug << "Warning: unable to parse the SSH config file.";
     }
 
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-    ssh_options_get_port (my_ssh_session, &cur_port);
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+    ssh_options_get_port(my_ssh_session, &cur_port);
     x2goDebug << "Session port after config file parse (part 2): " << cur_port;
 #endif
 
     return true;
 }
 
-
 void SshMasterConnection::writeKnownHosts(bool write)
 {
     writeHostKeyMutex.lock();
-    writeHostKeyReady=true;
-    writeHostKey=write;
-    if(!write)
+    writeHostKeyReady = true;
+    writeHostKey = write;
+    if (!write)
     {
-        breakLoop=true;
+        breakLoop = true;
         emit serverAuthAborted();
     }
     writeHostKeyMutex.unlock();
-
 }
 
-
-int SshMasterConnection::serverAuth ( QString& errorMsg )
+int SshMasterConnection::serverAuth(QString &errorMsg)
 {
-    x2goDebug<<"cserverAuth";
+    x2goDebug << "cserverAuth";
 
     int state = SSH_SERVER_ERROR;
     unsigned char *hash = NULL;
     char *hexa = NULL;
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-    ssh_key srv_pubkey = { 0 };
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+    ssh_key srv_pubkey = {0};
     int rc = SSH_ERROR;
     size_t hlen = 0;
 #else
     int hlen = 0;
 #endif
 
-    state = ssh_is_server_known ( my_ssh_session );
+    state = ssh_is_server_known(my_ssh_session);
 
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 8, 0)
-    rc = ssh_get_server_publickey (my_ssh_session, &srv_pubkey);
-#else /* LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 8, 0) */
-    rc = ssh_get_publickey (my_ssh_session, &srv_pubkey);
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 8, 0)
+    rc = ssh_get_server_publickey(my_ssh_session, &srv_pubkey);
+#else  /* LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 8, 0) */
+    rc = ssh_get_publickey(my_ssh_session, &srv_pubkey);
 #endif /* LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 8, 0) */
 
-    if (SSH_OK != rc) {
+    if (SSH_OK != rc)
+    {
         return (SSH_SERVER_ERROR);
     }
 
-    rc = ssh_get_publickey_hash (srv_pubkey, SSH_PUBLICKEY_HASH_SHA1, &hash, &hlen);
-    ssh_key_free (srv_pubkey);
+    rc = ssh_get_publickey_hash(srv_pubkey, SSH_PUBLICKEY_HASH_SHA1, &hash, &hlen);
+    ssh_key_free(srv_pubkey);
 
-    if (0 != rc) {
+    if (0 != rc)
+    {
         return (SSH_SERVER_ERROR);
     }
 #else
-    hlen = ssh_get_pubkey_hash ( my_ssh_session, &hash );
+    hlen = ssh_get_pubkey_hash(my_ssh_session, &hash);
 #endif
 
-    if ( 0 >= hlen )
+    if (0 >= hlen)
         return SSH_SERVER_ERROR;
 
-    x2goDebug<<"state: "<<state<<endl;
+    x2goDebug << "state: " << state << endl;
 
-    switch ( state )
+    switch (state)
     {
     case SSH_SERVER_KNOWN_OK:
         break; /* ok */
 
     case SSH_SERVER_KNOWN_CHANGED:
-        hexa = ssh_get_hexa ( hash, hlen );
-        errorMsg=host+":"+QString::number(port)+" - "+hexa;
-        ssh_string_free_char ( hexa );
+        hexa = ssh_get_hexa(hash, hlen);
+        errorMsg = host + ":" + QString::number(port) + " - " + hexa;
+        ssh_string_free_char(hexa);
         break;
     case SSH_SERVER_FOUND_OTHER:
         break;
     case SSH_SERVER_FILE_NOT_FOUND:
     case SSH_SERVER_NOT_KNOWN:
-        if ( !acceptUnknownServers )
+        if (!acceptUnknownServers)
         {
-            hexa = ssh_get_hexa ( hash, hlen );
-            errorMsg=host+":"+QString::number(port)+" - "+hexa;
-            ssh_string_free_char ( hexa );
+            hexa = ssh_get_hexa(hash, hlen);
+            errorMsg = host + ":" + QString::number(port) + " - " + hexa;
+            ssh_string_free_char(hexa);
             break;
         }
-        ssh_write_knownhost ( my_ssh_session );
-        state=SSH_SERVER_KNOWN_OK;
+        ssh_write_knownhost(my_ssh_session);
+        state = SSH_SERVER_KNOWN_OK;
         break;
 
     case SSH_SERVER_ERROR:
-        errorMsg=host+":"+QString::number(port)+" - "+ssh_get_error ( my_ssh_session );
+        errorMsg = host + ":" + QString::number(port) + " - " + ssh_get_error(my_ssh_session);
         break;
     }
-    ssh_clean_pubkey_hash ( &hash );
+    ssh_clean_pubkey_hash(&hash);
     return state;
 }
 
 void SshMasterConnection::setVerficationCode(QString code)
 {
-    challengeAuthVerificationCode=code;
+    challengeAuthVerificationCode = code;
 }
 
-
-
 bool SshMasterConnection::userAuthKeyboardInteractive(QString prompt)
 {
-    x2goDebug<<"Open Interaction dialog to complete authentication";
+    x2goDebug << "Open Interaction dialog to complete authentication";
     emit startInteraction(this, prompt);
-    interactionInterrupt=false;
-    interactionInputText=QString::null;
-    int rez=SSH_AUTH_INFO;
-    bool firstLoop=true;
-    int prompts=1;
+    interactionInterrupt = false;
+    interactionInputText = QString::null;
+    int rez = SSH_AUTH_INFO;
+    bool firstLoop = true;
+    int prompts = 1;
     QString instruction;
-    while (rez==SSH_AUTH_INFO)
+    while (rez == SSH_AUTH_INFO)
     {
 
-        if(firstLoop)
+        if (firstLoop)
         {
-            firstLoop=false;
+            firstLoop = false;
         }
         else
         {
-            prompts=ssh_userauth_kbdint_getnprompts(my_ssh_session);
-            if(prompts>0)
-                emit updateInteraction(this, ssh_userauth_kbdint_getprompt(my_ssh_session,0,NULL));
+            prompts = ssh_userauth_kbdint_getnprompts(my_ssh_session);
+            if (prompts > 0)
+                emit updateInteraction(this, ssh_userauth_kbdint_getprompt(my_ssh_session, 0, NULL));
 
-            QString name= ssh_userauth_kbdint_getname(my_ssh_session);
+            QString name = ssh_userauth_kbdint_getname(my_ssh_session);
             instruction = ssh_userauth_kbdint_getinstruction(my_ssh_session);
-            x2goDebug<<"Have prompts: "<<prompts<<endl;
-            x2goDebug<<"Name: "<<name<<endl;
-            x2goDebug<<"Instruction: "<<instruction<<endl;
+            x2goDebug << "Have prompts: " << prompts << endl;
+            x2goDebug << "Name: " << name << endl;
+            x2goDebug << "Instruction: " << instruction << endl;
         }
-        if(prompts>0)
+        if (prompts > 0)
         {
-            while(true)
+            while (true)
             {
                 bool interrupt;
                 interactionInputMutex.lock();
-                interrupt=interactionInterrupt;
-                QString textToSend=interactionInputText;
-                interactionInputText=QString::null;
+                interrupt = interactionInterrupt;
+                QString textToSend = interactionInputText;
+                interactionInputText = QString::null;
                 interactionInputMutex.unlock();
-                if(textToSend.length()>0)
+                if (textToSend.length() > 0)
                 {
-                    x2goDebug<<"SEND Input to SERVER";
-                    textToSend.replace("\n","");
-                    ssh_userauth_kbdint_setanswer(my_ssh_session,0,textToSend.toLocal8Bit());
+                    x2goDebug << "SEND Input to SERVER";
+                    textToSend.replace("\n", "");
+                    ssh_userauth_kbdint_setanswer(my_ssh_session, 0, textToSend.toLocal8Bit());
                     break;
                 }
-                if(interrupt)
+                if (interrupt)
                 {
-                    x2goDebug<<"Keyboard authentication failed";
-//         QString err=ssh_get_error ( my_ssh_session );
-                    authErrors<<"NO_ERROR";
+                    x2goDebug << "Keyboard authentication failed";
+                    //         QString err=ssh_get_error ( my_ssh_session );
+                    authErrors << "NO_ERROR";
                     emit finishInteraction(this);
 
                     return false;
